// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: CSIDXInfor.proto

package com.fss.fo.mserver.exchange;

public final class CSIDXInforProtos {
  private CSIDXInforProtos() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface CSIDXInforOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string Id = 1;
    /**
     * <code>optional string Id = 1;</code>
     */
    boolean hasId();
    /**
     * <code>optional string Id = 1;</code>
     */
    java.lang.String getId();
    /**
     * <code>optional string Id = 1;</code>
     */
    com.google.protobuf.ByteString
        getIdBytes();

    // optional string IndexCode = 2;
    /**
     * <code>optional string IndexCode = 2;</code>
     */
    boolean hasIndexCode();
    /**
     * <code>optional string IndexCode = 2;</code>
     */
    java.lang.String getIndexCode();
    /**
     * <code>optional string IndexCode = 2;</code>
     */
    com.google.protobuf.ByteString
        getIndexCodeBytes();

    // optional string StockNo = 3;
    /**
     * <code>optional string StockNo = 3;</code>
     */
    boolean hasStockNo();
    /**
     * <code>optional string StockNo = 3;</code>
     */
    java.lang.String getStockNo();
    /**
     * <code>optional string StockNo = 3;</code>
     */
    com.google.protobuf.ByteString
        getStockNoBytes();

    // optional string Symbol = 4;
    /**
     * <code>optional string Symbol = 4;</code>
     */
    boolean hasSymbol();
    /**
     * <code>optional string Symbol = 4;</code>
     */
    java.lang.String getSymbol();
    /**
     * <code>optional string Symbol = 4;</code>
     */
    com.google.protobuf.ByteString
        getSymbolBytes();

    // optional string TotalQtty = 5;
    /**
     * <code>optional string TotalQtty = 5;</code>
     */
    boolean hasTotalQtty();
    /**
     * <code>optional string TotalQtty = 5;</code>
     */
    java.lang.String getTotalQtty();
    /**
     * <code>optional string TotalQtty = 5;</code>
     */
    com.google.protobuf.ByteString
        getTotalQttyBytes();

    // optional string Weighted = 6;
    /**
     * <code>optional string Weighted = 6;</code>
     */
    boolean hasWeighted();
    /**
     * <code>optional string Weighted = 6;</code>
     */
    java.lang.String getWeighted();
    /**
     * <code>optional string Weighted = 6;</code>
     */
    com.google.protobuf.ByteString
        getWeightedBytes();

    // optional string AddDate = 7;
    /**
     * <code>optional string AddDate = 7;</code>
     */
    boolean hasAddDate();
    /**
     * <code>optional string AddDate = 7;</code>
     */
    java.lang.String getAddDate();
    /**
     * <code>optional string AddDate = 7;</code>
     */
    com.google.protobuf.ByteString
        getAddDateBytes();

    // optional int32 IndexId = 8;
    /**
     * <code>optional int32 IndexId = 8;</code>
     */
    boolean hasIndexId();
    /**
     * <code>optional int32 IndexId = 8;</code>
     */
    int getIndexId();

    // optional string FloorCode = 9;
    /**
     * <code>optional string FloorCode = 9;</code>
     */
    boolean hasFloorCode();
    /**
     * <code>optional string FloorCode = 9;</code>
     */
    java.lang.String getFloorCode();
    /**
     * <code>optional string FloorCode = 9;</code>
     */
    com.google.protobuf.ByteString
        getFloorCodeBytes();

    // optional string TradingDate = 10;
    /**
     * <code>optional string TradingDate = 10;</code>
     */
    boolean hasTradingDate();
    /**
     * <code>optional string TradingDate = 10;</code>
     */
    java.lang.String getTradingDate();
    /**
     * <code>optional string TradingDate = 10;</code>
     */
    com.google.protobuf.ByteString
        getTradingDateBytes();
  }
  /**
   * Protobuf type {@code com.fss.fo.mserver.exchange.CSIDXInfor}
   */
  public static final class CSIDXInfor extends
      com.google.protobuf.GeneratedMessage
      implements CSIDXInforOrBuilder {
    // Use CSIDXInfor.newBuilder() to construct.
    private CSIDXInfor(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private CSIDXInfor(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final CSIDXInfor defaultInstance;
    public static CSIDXInfor getDefaultInstance() {
      return defaultInstance;
    }

    public CSIDXInfor getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private CSIDXInfor(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              id_ = input.readBytes();
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              indexCode_ = input.readBytes();
              break;
            }
            case 26: {
              bitField0_ |= 0x00000004;
              stockNo_ = input.readBytes();
              break;
            }
            case 34: {
              bitField0_ |= 0x00000008;
              symbol_ = input.readBytes();
              break;
            }
            case 42: {
              bitField0_ |= 0x00000010;
              totalQtty_ = input.readBytes();
              break;
            }
            case 50: {
              bitField0_ |= 0x00000020;
              weighted_ = input.readBytes();
              break;
            }
            case 58: {
              bitField0_ |= 0x00000040;
              addDate_ = input.readBytes();
              break;
            }
            case 64: {
              bitField0_ |= 0x00000080;
              indexId_ = input.readInt32();
              break;
            }
            case 74: {
              bitField0_ |= 0x00000100;
              floorCode_ = input.readBytes();
              break;
            }
            case 82: {
              bitField0_ |= 0x00000200;
              tradingDate_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.fss.fo.mserver.exchange.CSIDXInforProtos.internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.fss.fo.mserver.exchange.CSIDXInforProtos.internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor.class, com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor.Builder.class);
    }

    public static com.google.protobuf.Parser<CSIDXInfor> PARSER =
        new com.google.protobuf.AbstractParser<CSIDXInfor>() {
      public CSIDXInfor parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new CSIDXInfor(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<CSIDXInfor> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional string Id = 1;
    public static final int ID_FIELD_NUMBER = 1;
    private java.lang.Object id_;
    /**
     * <code>optional string Id = 1;</code>
     */
    public boolean hasId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public java.lang.String getId() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          id_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public com.google.protobuf.ByteString
        getIdBytes() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        id_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string IndexCode = 2;
    public static final int INDEXCODE_FIELD_NUMBER = 2;
    private java.lang.Object indexCode_;
    /**
     * <code>optional string IndexCode = 2;</code>
     */
    public boolean hasIndexCode() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional string IndexCode = 2;</code>
     */
    public java.lang.String getIndexCode() {
      java.lang.Object ref = indexCode_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          indexCode_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string IndexCode = 2;</code>
     */
    public com.google.protobuf.ByteString
        getIndexCodeBytes() {
      java.lang.Object ref = indexCode_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        indexCode_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string StockNo = 3;
    public static final int STOCKNO_FIELD_NUMBER = 3;
    private java.lang.Object stockNo_;
    /**
     * <code>optional string StockNo = 3;</code>
     */
    public boolean hasStockNo() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>optional string StockNo = 3;</code>
     */
    public java.lang.String getStockNo() {
      java.lang.Object ref = stockNo_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          stockNo_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string StockNo = 3;</code>
     */
    public com.google.protobuf.ByteString
        getStockNoBytes() {
      java.lang.Object ref = stockNo_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        stockNo_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Symbol = 4;
    public static final int SYMBOL_FIELD_NUMBER = 4;
    private java.lang.Object symbol_;
    /**
     * <code>optional string Symbol = 4;</code>
     */
    public boolean hasSymbol() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>optional string Symbol = 4;</code>
     */
    public java.lang.String getSymbol() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          symbol_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Symbol = 4;</code>
     */
    public com.google.protobuf.ByteString
        getSymbolBytes() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        symbol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string TotalQtty = 5;
    public static final int TOTALQTTY_FIELD_NUMBER = 5;
    private java.lang.Object totalQtty_;
    /**
     * <code>optional string TotalQtty = 5;</code>
     */
    public boolean hasTotalQtty() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    /**
     * <code>optional string TotalQtty = 5;</code>
     */
    public java.lang.String getTotalQtty() {
      java.lang.Object ref = totalQtty_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          totalQtty_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string TotalQtty = 5;</code>
     */
    public com.google.protobuf.ByteString
        getTotalQttyBytes() {
      java.lang.Object ref = totalQtty_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        totalQtty_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Weighted = 6;
    public static final int WEIGHTED_FIELD_NUMBER = 6;
    private java.lang.Object weighted_;
    /**
     * <code>optional string Weighted = 6;</code>
     */
    public boolean hasWeighted() {
      return ((bitField0_ & 0x00000020) == 0x00000020);
    }
    /**
     * <code>optional string Weighted = 6;</code>
     */
    public java.lang.String getWeighted() {
      java.lang.Object ref = weighted_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          weighted_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Weighted = 6;</code>
     */
    public com.google.protobuf.ByteString
        getWeightedBytes() {
      java.lang.Object ref = weighted_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        weighted_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string AddDate = 7;
    public static final int ADDDATE_FIELD_NUMBER = 7;
    private java.lang.Object addDate_;
    /**
     * <code>optional string AddDate = 7;</code>
     */
    public boolean hasAddDate() {
      return ((bitField0_ & 0x00000040) == 0x00000040);
    }
    /**
     * <code>optional string AddDate = 7;</code>
     */
    public java.lang.String getAddDate() {
      java.lang.Object ref = addDate_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          addDate_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string AddDate = 7;</code>
     */
    public com.google.protobuf.ByteString
        getAddDateBytes() {
      java.lang.Object ref = addDate_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        addDate_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional int32 IndexId = 8;
    public static final int INDEXID_FIELD_NUMBER = 8;
    private int indexId_;
    /**
     * <code>optional int32 IndexId = 8;</code>
     */
    public boolean hasIndexId() {
      return ((bitField0_ & 0x00000080) == 0x00000080);
    }
    /**
     * <code>optional int32 IndexId = 8;</code>
     */
    public int getIndexId() {
      return indexId_;
    }

    // optional string FloorCode = 9;
    public static final int FLOORCODE_FIELD_NUMBER = 9;
    private java.lang.Object floorCode_;
    /**
     * <code>optional string FloorCode = 9;</code>
     */
    public boolean hasFloorCode() {
      return ((bitField0_ & 0x00000100) == 0x00000100);
    }
    /**
     * <code>optional string FloorCode = 9;</code>
     */
    public java.lang.String getFloorCode() {
      java.lang.Object ref = floorCode_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          floorCode_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string FloorCode = 9;</code>
     */
    public com.google.protobuf.ByteString
        getFloorCodeBytes() {
      java.lang.Object ref = floorCode_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        floorCode_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string TradingDate = 10;
    public static final int TRADINGDATE_FIELD_NUMBER = 10;
    private java.lang.Object tradingDate_;
    /**
     * <code>optional string TradingDate = 10;</code>
     */
    public boolean hasTradingDate() {
      return ((bitField0_ & 0x00000200) == 0x00000200);
    }
    /**
     * <code>optional string TradingDate = 10;</code>
     */
    public java.lang.String getTradingDate() {
      java.lang.Object ref = tradingDate_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          tradingDate_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string TradingDate = 10;</code>
     */
    public com.google.protobuf.ByteString
        getTradingDateBytes() {
      java.lang.Object ref = tradingDate_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        tradingDate_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      id_ = "";
      indexCode_ = "";
      stockNo_ = "";
      symbol_ = "";
      totalQtty_ = "";
      weighted_ = "";
      addDate_ = "";
      indexId_ = 0;
      floorCode_ = "";
      tradingDate_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, getIndexCodeBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeBytes(3, getStockNoBytes());
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeBytes(4, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeBytes(5, getTotalQttyBytes());
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        output.writeBytes(6, getWeightedBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        output.writeBytes(7, getAddDateBytes());
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        output.writeInt32(8, indexId_);
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        output.writeBytes(9, getFloorCodeBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        output.writeBytes(10, getTradingDateBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, getIndexCodeBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(3, getStockNoBytes());
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(4, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(5, getTotalQttyBytes());
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(6, getWeightedBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(7, getAddDateBytes());
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(8, indexId_);
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(9, getFloorCodeBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(10, getTradingDateBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code com.fss.fo.mserver.exchange.CSIDXInfor}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInforOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.fss.fo.mserver.exchange.CSIDXInforProtos.internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.fss.fo.mserver.exchange.CSIDXInforProtos.internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor.class, com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor.Builder.class);
      }

      // Construct using com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        id_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        indexCode_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        stockNo_ = "";
        bitField0_ = (bitField0_ & ~0x00000004);
        symbol_ = "";
        bitField0_ = (bitField0_ & ~0x00000008);
        totalQtty_ = "";
        bitField0_ = (bitField0_ & ~0x00000010);
        weighted_ = "";
        bitField0_ = (bitField0_ & ~0x00000020);
        addDate_ = "";
        bitField0_ = (bitField0_ & ~0x00000040);
        indexId_ = 0;
        bitField0_ = (bitField0_ & ~0x00000080);
        floorCode_ = "";
        bitField0_ = (bitField0_ & ~0x00000100);
        tradingDate_ = "";
        bitField0_ = (bitField0_ & ~0x00000200);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.fss.fo.mserver.exchange.CSIDXInforProtos.internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_descriptor;
      }

      public com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor getDefaultInstanceForType() {
        return com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor.getDefaultInstance();
      }

      public com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor build() {
        com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor buildPartial() {
        com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor result = new com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.id_ = id_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.indexCode_ = indexCode_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.stockNo_ = stockNo_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.symbol_ = symbol_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.totalQtty_ = totalQtty_;
        if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
          to_bitField0_ |= 0x00000020;
        }
        result.weighted_ = weighted_;
        if (((from_bitField0_ & 0x00000040) == 0x00000040)) {
          to_bitField0_ |= 0x00000040;
        }
        result.addDate_ = addDate_;
        if (((from_bitField0_ & 0x00000080) == 0x00000080)) {
          to_bitField0_ |= 0x00000080;
        }
        result.indexId_ = indexId_;
        if (((from_bitField0_ & 0x00000100) == 0x00000100)) {
          to_bitField0_ |= 0x00000100;
        }
        result.floorCode_ = floorCode_;
        if (((from_bitField0_ & 0x00000200) == 0x00000200)) {
          to_bitField0_ |= 0x00000200;
        }
        result.tradingDate_ = tradingDate_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor) {
          return mergeFrom((com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor other) {
        if (other == com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor.getDefaultInstance()) return this;
        if (other.hasId()) {
          bitField0_ |= 0x00000001;
          id_ = other.id_;
          onChanged();
        }
        if (other.hasIndexCode()) {
          bitField0_ |= 0x00000002;
          indexCode_ = other.indexCode_;
          onChanged();
        }
        if (other.hasStockNo()) {
          bitField0_ |= 0x00000004;
          stockNo_ = other.stockNo_;
          onChanged();
        }
        if (other.hasSymbol()) {
          bitField0_ |= 0x00000008;
          symbol_ = other.symbol_;
          onChanged();
        }
        if (other.hasTotalQtty()) {
          bitField0_ |= 0x00000010;
          totalQtty_ = other.totalQtty_;
          onChanged();
        }
        if (other.hasWeighted()) {
          bitField0_ |= 0x00000020;
          weighted_ = other.weighted_;
          onChanged();
        }
        if (other.hasAddDate()) {
          bitField0_ |= 0x00000040;
          addDate_ = other.addDate_;
          onChanged();
        }
        if (other.hasIndexId()) {
          setIndexId(other.getIndexId());
        }
        if (other.hasFloorCode()) {
          bitField0_ |= 0x00000100;
          floorCode_ = other.floorCode_;
          onChanged();
        }
        if (other.hasTradingDate()) {
          bitField0_ |= 0x00000200;
          tradingDate_ = other.tradingDate_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (com.fss.fo.mserver.exchange.CSIDXInforProtos.CSIDXInfor) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string Id = 1;
      private java.lang.Object id_ = "";
      /**
       * <code>optional string Id = 1;</code>
       */
      public boolean hasId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public java.lang.String getId() {
        java.lang.Object ref = id_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          id_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public com.google.protobuf.ByteString
          getIdBytes() {
        java.lang.Object ref = id_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          id_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setId(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder clearId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        id_ = getDefaultInstance().getId();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setIdBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }

      // optional string IndexCode = 2;
      private java.lang.Object indexCode_ = "";
      /**
       * <code>optional string IndexCode = 2;</code>
       */
      public boolean hasIndexCode() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional string IndexCode = 2;</code>
       */
      public java.lang.String getIndexCode() {
        java.lang.Object ref = indexCode_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          indexCode_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string IndexCode = 2;</code>
       */
      public com.google.protobuf.ByteString
          getIndexCodeBytes() {
        java.lang.Object ref = indexCode_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          indexCode_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string IndexCode = 2;</code>
       */
      public Builder setIndexCode(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        indexCode_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string IndexCode = 2;</code>
       */
      public Builder clearIndexCode() {
        bitField0_ = (bitField0_ & ~0x00000002);
        indexCode_ = getDefaultInstance().getIndexCode();
        onChanged();
        return this;
      }
      /**
       * <code>optional string IndexCode = 2;</code>
       */
      public Builder setIndexCodeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        indexCode_ = value;
        onChanged();
        return this;
      }

      // optional string StockNo = 3;
      private java.lang.Object stockNo_ = "";
      /**
       * <code>optional string StockNo = 3;</code>
       */
      public boolean hasStockNo() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional string StockNo = 3;</code>
       */
      public java.lang.String getStockNo() {
        java.lang.Object ref = stockNo_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          stockNo_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string StockNo = 3;</code>
       */
      public com.google.protobuf.ByteString
          getStockNoBytes() {
        java.lang.Object ref = stockNo_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          stockNo_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string StockNo = 3;</code>
       */
      public Builder setStockNo(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        stockNo_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string StockNo = 3;</code>
       */
      public Builder clearStockNo() {
        bitField0_ = (bitField0_ & ~0x00000004);
        stockNo_ = getDefaultInstance().getStockNo();
        onChanged();
        return this;
      }
      /**
       * <code>optional string StockNo = 3;</code>
       */
      public Builder setStockNoBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        stockNo_ = value;
        onChanged();
        return this;
      }

      // optional string Symbol = 4;
      private java.lang.Object symbol_ = "";
      /**
       * <code>optional string Symbol = 4;</code>
       */
      public boolean hasSymbol() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>optional string Symbol = 4;</code>
       */
      public java.lang.String getSymbol() {
        java.lang.Object ref = symbol_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          symbol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Symbol = 4;</code>
       */
      public com.google.protobuf.ByteString
          getSymbolBytes() {
        java.lang.Object ref = symbol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          symbol_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Symbol = 4;</code>
       */
      public Builder setSymbol(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        symbol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Symbol = 4;</code>
       */
      public Builder clearSymbol() {
        bitField0_ = (bitField0_ & ~0x00000008);
        symbol_ = getDefaultInstance().getSymbol();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Symbol = 4;</code>
       */
      public Builder setSymbolBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        symbol_ = value;
        onChanged();
        return this;
      }

      // optional string TotalQtty = 5;
      private java.lang.Object totalQtty_ = "";
      /**
       * <code>optional string TotalQtty = 5;</code>
       */
      public boolean hasTotalQtty() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      /**
       * <code>optional string TotalQtty = 5;</code>
       */
      public java.lang.String getTotalQtty() {
        java.lang.Object ref = totalQtty_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          totalQtty_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string TotalQtty = 5;</code>
       */
      public com.google.protobuf.ByteString
          getTotalQttyBytes() {
        java.lang.Object ref = totalQtty_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          totalQtty_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string TotalQtty = 5;</code>
       */
      public Builder setTotalQtty(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        totalQtty_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string TotalQtty = 5;</code>
       */
      public Builder clearTotalQtty() {
        bitField0_ = (bitField0_ & ~0x00000010);
        totalQtty_ = getDefaultInstance().getTotalQtty();
        onChanged();
        return this;
      }
      /**
       * <code>optional string TotalQtty = 5;</code>
       */
      public Builder setTotalQttyBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        totalQtty_ = value;
        onChanged();
        return this;
      }

      // optional string Weighted = 6;
      private java.lang.Object weighted_ = "";
      /**
       * <code>optional string Weighted = 6;</code>
       */
      public boolean hasWeighted() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      /**
       * <code>optional string Weighted = 6;</code>
       */
      public java.lang.String getWeighted() {
        java.lang.Object ref = weighted_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          weighted_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Weighted = 6;</code>
       */
      public com.google.protobuf.ByteString
          getWeightedBytes() {
        java.lang.Object ref = weighted_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          weighted_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Weighted = 6;</code>
       */
      public Builder setWeighted(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        weighted_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Weighted = 6;</code>
       */
      public Builder clearWeighted() {
        bitField0_ = (bitField0_ & ~0x00000020);
        weighted_ = getDefaultInstance().getWeighted();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Weighted = 6;</code>
       */
      public Builder setWeightedBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        weighted_ = value;
        onChanged();
        return this;
      }

      // optional string AddDate = 7;
      private java.lang.Object addDate_ = "";
      /**
       * <code>optional string AddDate = 7;</code>
       */
      public boolean hasAddDate() {
        return ((bitField0_ & 0x00000040) == 0x00000040);
      }
      /**
       * <code>optional string AddDate = 7;</code>
       */
      public java.lang.String getAddDate() {
        java.lang.Object ref = addDate_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          addDate_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string AddDate = 7;</code>
       */
      public com.google.protobuf.ByteString
          getAddDateBytes() {
        java.lang.Object ref = addDate_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          addDate_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string AddDate = 7;</code>
       */
      public Builder setAddDate(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000040;
        addDate_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string AddDate = 7;</code>
       */
      public Builder clearAddDate() {
        bitField0_ = (bitField0_ & ~0x00000040);
        addDate_ = getDefaultInstance().getAddDate();
        onChanged();
        return this;
      }
      /**
       * <code>optional string AddDate = 7;</code>
       */
      public Builder setAddDateBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000040;
        addDate_ = value;
        onChanged();
        return this;
      }

      // optional int32 IndexId = 8;
      private int indexId_ ;
      /**
       * <code>optional int32 IndexId = 8;</code>
       */
      public boolean hasIndexId() {
        return ((bitField0_ & 0x00000080) == 0x00000080);
      }
      /**
       * <code>optional int32 IndexId = 8;</code>
       */
      public int getIndexId() {
        return indexId_;
      }
      /**
       * <code>optional int32 IndexId = 8;</code>
       */
      public Builder setIndexId(int value) {
        bitField0_ |= 0x00000080;
        indexId_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int32 IndexId = 8;</code>
       */
      public Builder clearIndexId() {
        bitField0_ = (bitField0_ & ~0x00000080);
        indexId_ = 0;
        onChanged();
        return this;
      }

      // optional string FloorCode = 9;
      private java.lang.Object floorCode_ = "";
      /**
       * <code>optional string FloorCode = 9;</code>
       */
      public boolean hasFloorCode() {
        return ((bitField0_ & 0x00000100) == 0x00000100);
      }
      /**
       * <code>optional string FloorCode = 9;</code>
       */
      public java.lang.String getFloorCode() {
        java.lang.Object ref = floorCode_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          floorCode_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string FloorCode = 9;</code>
       */
      public com.google.protobuf.ByteString
          getFloorCodeBytes() {
        java.lang.Object ref = floorCode_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          floorCode_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string FloorCode = 9;</code>
       */
      public Builder setFloorCode(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        floorCode_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string FloorCode = 9;</code>
       */
      public Builder clearFloorCode() {
        bitField0_ = (bitField0_ & ~0x00000100);
        floorCode_ = getDefaultInstance().getFloorCode();
        onChanged();
        return this;
      }
      /**
       * <code>optional string FloorCode = 9;</code>
       */
      public Builder setFloorCodeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        floorCode_ = value;
        onChanged();
        return this;
      }

      // optional string TradingDate = 10;
      private java.lang.Object tradingDate_ = "";
      /**
       * <code>optional string TradingDate = 10;</code>
       */
      public boolean hasTradingDate() {
        return ((bitField0_ & 0x00000200) == 0x00000200);
      }
      /**
       * <code>optional string TradingDate = 10;</code>
       */
      public java.lang.String getTradingDate() {
        java.lang.Object ref = tradingDate_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          tradingDate_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string TradingDate = 10;</code>
       */
      public com.google.protobuf.ByteString
          getTradingDateBytes() {
        java.lang.Object ref = tradingDate_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          tradingDate_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string TradingDate = 10;</code>
       */
      public Builder setTradingDate(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000200;
        tradingDate_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string TradingDate = 10;</code>
       */
      public Builder clearTradingDate() {
        bitField0_ = (bitField0_ & ~0x00000200);
        tradingDate_ = getDefaultInstance().getTradingDate();
        onChanged();
        return this;
      }
      /**
       * <code>optional string TradingDate = 10;</code>
       */
      public Builder setTradingDateBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000200;
        tradingDate_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:com.fss.fo.mserver.exchange.CSIDXInfor)
    }

    static {
      defaultInstance = new CSIDXInfor(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:com.fss.fo.mserver.exchange.CSIDXInfor)
  }

  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\020CSIDXInfor.proto\022\033com.fss.fo.mserver.e" +
      "xchange\"\273\001\n\nCSIDXInfor\022\n\n\002Id\030\001 \001(\t\022\021\n\tIn" +
      "dexCode\030\002 \001(\t\022\017\n\007StockNo\030\003 \001(\t\022\016\n\006Symbol" +
      "\030\004 \001(\t\022\021\n\tTotalQtty\030\005 \001(\t\022\020\n\010Weighted\030\006 " +
      "\001(\t\022\017\n\007AddDate\030\007 \001(\t\022\017\n\007IndexId\030\010 \001(\005\022\021\n" +
      "\tFloorCode\030\t \001(\t\022\023\n\013TradingDate\030\n \001(\tB/\n" +
      "\033com.fss.fo.mserver.exchangeB\020CSIDXInfor" +
      "Protos"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_fss_fo_mserver_exchange_CSIDXInfor_descriptor,
              new java.lang.String[] { "Id", "IndexCode", "StockNo", "Symbol", "TotalQtty", "Weighted", "AddDate", "IndexId", "FloorCode", "TradingDate", });
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }

  // @@protoc_insertion_point(outer_class_scope)
}
